/***********************************************************************/
/*  IIC-Interface  Testprogramm f. TSA5523		               */
/*  V0.1  erstellt am  : 19.02.2001 / I. Gerlach                       */
/*  Dateiname          : test_tsa.c				       */
/*                                     				       */
/*  Aenderungen : 						       */
/*                                                                     */
/*                                                                     */
/* 					                               */
/* *********************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "../i2c_ser/i2c_ser.h" 		// i2c Funktionen
//#include "../src/lcd.h"
#include "tsa5523.h"


int main(int argc, char *argv[]) {

 int test;
 int opt;

 
  // long f = 106900000;
   long f =  400000000 ;
  
   while((opt=getopt(argc, argv, ":f:")) != EOF)
    switch(opt)
   {
 
    case 'f':
     f=atol(optarg);
     break;
   }  
       
 printf("*** ic-TSA5523 Test (c) Ingo Gerlach 02/2001 *** \n");
 set_port_delay(9);		// Portdelay 0-255 
 test = init_iic(0);		// Init ii2c 0, automatisch suchen
 printf("Suche i2c-Interface...");
 printf("Test %d \n",test);
 if (test) 
 {
  printf(" gefunden an Port 0x%03xh! \n",test);
 } else {
    printf("Interface nicht gefunden.\n");
    exit (0);
  }
  set_strobe(1);			// Fr den Seriellen Port nur dummy, Parport 
  io_disable();				// 8 Bit I/O disablen
 
  test = tsa5523_init(&tsa5,TSA5523_PLL);  // Daten initialisieren Datenstruktur, 
  					  // ZF (in HZ) , Mode SDA3302_PLL/SDA3302_DIV

  printf(" Init %d \n",tsa5.cnt1);  						  
  test  = tsa5523_calc(&tsa5,f,0);
  printf("Freq: %ld , Teiler n %d , Fres: %d\n",f,test,((test*TSA5523_STEP)-TSA5523_ZF));
  printf(" Div 1 : %d \n",tsa5.div1);
  printf(" Div 2 : %d \n",tsa5.div2);
  printf(" Cont1 : %d \n",tsa5.cnt1);
  printf(" Cont2 : %d \n",tsa5.cnt2);
  printf("Ret: %d \n",tsa5523_send(&tsa5,0));
  printf("Read %d \n",tsa5523_read(0));

  printf("deinit %d\n",deinit_iic()); 
 return 0;
}
